"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Creator = exports.truncatePubkey = void 0;
const react_1 = __importDefault(require("react"));
const react_2 = require("@chakra-ui/react");
const hooks_1 = require("../hooks");
const react_router_dom_1 = require("react-router-dom");
const web3_js_1 = require("@solana/web3.js");
const nameService_1 = require("../hooks/nameService");
const WUMBO_TWITTER_VERIFIER = new web3_js_1.PublicKey("DTok7pfUzNeNPqU3Q6foySCezPQE82eRyhX1HdhVNLVC");
const WUMBO_TWITTER_TLD = new web3_js_1.PublicKey("Fhqd3ostRQQE65hzoA7xFMgT9kge2qPnsTNAKuL2yrnx");
const truncatePubkey = (pkey) => {
    const pkeyStr = pkey.toString();
    return `${pkeyStr.substr(0, 4)}...${pkeyStr.substr(pkeyStr.length - 4)}`;
};
exports.truncatePubkey = truncatePubkey;
exports.Creator = react_1.default.memo(({ creator, getCreatorLink, }) => {
    const { handleErrors } = (0, hooks_1.useErrorHandler)();
    const { metadata, tokenRef, error, image } = (0, hooks_1.useSocialTokenMetadata)(creator);
    const { nameString: handle, error: reverseTwitterError2 } = (0, nameService_1.useReverseName)(creator, WUMBO_TWITTER_VERIFIER, WUMBO_TWITTER_TLD);
    handleErrors(error, reverseTwitterError2);
    const children = (react_1.default.createElement(react_1.default.Fragment, null,
        metadata && (react_1.default.createElement(react_2.Avatar, { showDetails: true, size: "xs", src: image, name: metadata.data.name })),
        !metadata && !handle && (0, exports.truncatePubkey)(creator),
        !metadata && handle && `@${handle}`));
    // @ts-ignore
    const link = getCreatorLink(creator, metadata, tokenRef, handle);
    if (link.includes("http")) {
        return (react_1.default.createElement(react_2.Link, { ml: "1", mr: "1", href: link }, children));
    }
    return react_1.default.createElement(react_router_dom_1.Link, { to: link }, children);
});
//# sourceMappingURL=Creator.js.map